"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
require("mocha");
var t = require("io-ts");
var tdc = require("io-ts-derive-class");
var index_1 = require("./index");
var registry = new index_1.ValidationRegistry();
var AddressType = t.type({
    ID: t.number,
    StreetAddress1: t.string,
    City: t.string,
    State: t.string
});
var Address = /** @class */ (function (_super) {
    __extends(Address, _super);
    function Address() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Address;
}(tdc.DeriveClass(AddressType)));
registry.register(Address, {
    StreetAddress1: index_1.required()
});
var PersonType = t.type({
    ID: t.number,
    FirstName: t.string,
    LastName: t.string,
    Email: t.union([t.string, t.null]),
    Phone: t.union([t.string, t.null]),
    Addresses: t.array(tdc.ref(Address))
});
var Person = /** @class */ (function (_super) {
    __extends(Person, _super);
    function Person() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Person;
}(tdc.DeriveClass(PersonType)));
var mustHaveContactMethodValidator = function (p) {
    var validResult = { Email: null, Phone: null, Addresses: null };
    if (p.Email !== null || p.Phone !== null || p.Addresses.length > 1) {
        return validResult;
    }
    var message = "A person must have an Email or a Phone or a Physical Address!";
    return { Email: message, Phone: message, Addresses: message };
};
registry.register(Person, {
    FirstName: index_1.required(),
    LastName: [index_1.required(), index_1.min(1)],
    Email: mustHaveContactMethodValidator,
    Phone: mustHaveContactMethodValidator,
    Addresses: mustHaveContactMethodValidator
});
describe('Array errors', function () {
    it('Array with complex validation rules returns correct error shape', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, personResult, personIsValid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person({
                        FirstName: "Test",
                        LastName: "Test",
                        Addresses: [new Address()]
                    });
                    return [4 /*yield*/, registry.validate(person, {})];
                case 1:
                    personResult = _a.sent();
                    chai_1.expect(personResult.Addresses.length).eq(1);
                    chai_1.expect(personResult.Addresses.errors.length).eq(1);
                    personIsValid = index_1.isValid(personResult);
                    chai_1.expect(personIsValid).eq(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=arrayerrors.spec.js.map