"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var PathReporter_1 = require("io-ts/lib/PathReporter");
function isPrimitive(input) {
    return typeof input === "string"
        || typeof input === "boolean"
        || typeof input === "number"
        || input === null
        || input === undefined
        || input instanceof Date;
}
var FieldValidator = /** @class */ (function () {
    function FieldValidator() {
        this.tag = 'FieldValidator';
    }
    return FieldValidator;
}());
exports.FieldValidator = FieldValidator;
function isFieldValidator(input) {
    return input['tag'] === 'FieldValidator';
}
var RequiredValidator = /** @class */ (function (_super) {
    __extends(RequiredValidator, _super);
    function RequiredValidator(message) {
        var _this = _super.call(this) || this;
        _this.message = message;
        _this.isRequiredFieldValidator = true;
        return _this;
    }
    RequiredValidator.prototype.validate = function (value) {
        if (value === null || value === undefined) {
            return this.message;
        }
        if (value.length < 1) {
            return this.message;
        }
        return null;
    };
    return RequiredValidator;
}(FieldValidator));
function isRequiredFieldValidator(input) {
    return input && input.isRequiredFieldValidator === true;
}
var MinValidator = /** @class */ (function (_super) {
    __extends(MinValidator, _super);
    function MinValidator(min, message) {
        if (message === void 0) { message = null; }
        var _this = _super.call(this) || this;
        _this.min = min;
        _this.message = message;
        return _this;
    }
    MinValidator.prototype.validate = function (value) {
        if (value === null || value === undefined) {
            return null;
        }
        if (value.length < this.min) {
            if (this.message) {
                return this.message;
            }
            if (typeof value === 'string') {
                return 'must be at least ' + this.min + ' characters';
            }
            if (Array.isArray(value)) {
                return 'must have at least ' + this.min + ' entries';
            }
        }
        if (value < this.min) {
            return this.message || 'must be greater than ' + (this.min - 1);
        }
        return null;
    };
    return MinValidator;
}(FieldValidator));
var MaxValidator = /** @class */ (function (_super) {
    __extends(MaxValidator, _super);
    function MaxValidator(max, message) {
        if (message === void 0) { message = null; }
        var _this = _super.call(this) || this;
        _this.max = max;
        _this.message = message;
        return _this;
    }
    MaxValidator.prototype.validate = function (value) {
        if (value === null || value === undefined) {
            return null;
        }
        if (value.length > this.max) {
            if (this.message) {
                return this.message;
            }
            if (typeof value === 'string') {
                return 'must be fewer than ' + (this.max + 1) + ' characters';
            }
            if (Array.isArray(value)) {
                return 'must be fewer than ' + (this.max + 1) + ' entries';
            }
        }
        if (value > this.max) {
            return this.message || 'must be less than ' + (this.max + 1);
        }
        return null;
    };
    return MaxValidator;
}(FieldValidator));
exports.required = function (message) {
    if (message === void 0) { message = 'is required'; }
    return new RequiredValidator(message);
};
exports.min = function (min, message) {
    if (message === void 0) { message = null; }
    return new MinValidator(min, message);
};
exports.max = function (max, message) {
    if (message === void 0) { message = null; }
    return new MaxValidator(max, message);
};
var ValidationRegistry = /** @class */ (function () {
    function ValidationRegistry() {
        this.map = new Map();
    }
    ValidationRegistry.prototype.getValidatorsFor = function (klass) {
        return this.map.get(klass) || {};
    };
    ValidationRegistry.prototype.register = function (klass, map) {
        var currentMap = this.getValidatorsFor(klass);
        var _loop_1 = function (prop) {
            var currentValidators = (currentMap[prop] || []);
            var mapped = map[prop];
            if (mapped instanceof Array) {
                var m = mapped;
                m.forEach(function (m) {
                    currentValidators.push(m);
                });
            }
            else {
                currentValidators.push(mapped);
            }
            currentMap[prop] = currentValidators;
        };
        for (var prop in map) {
            _loop_1(prop);
        }
        this.map.set(klass, currentMap);
    };
    ValidationRegistry.prototype.validate = function (model, ctx, originalModel, validationPath, path) {
        if (originalModel === void 0) { originalModel = undefined; }
        if (validationPath === void 0) { validationPath = null; }
        if (path === void 0) { path = '.'; }
        return __awaiter(this, void 0, void 0, function () {
            function add(key, res) {
                var keyIsArray = Array.isArray(model[key]);
                if (keyIsArray) {
                    addToArray(key, res);
                    return;
                }
                if (isRecord(res)) {
                    var r = res;
                    for (var k in r) {
                        add(k, r[k]);
                    }
                    return;
                }
                var current = result[key] || [];
                if (res !== null && current.indexOf(res) === -1) {
                    current.push(res);
                }
                result[key] = current;
            }
            function addToArray(key, res) {
                if (res === null)
                    return;
                function innerAdd(key, res) {
                    var current = result[key] || [];
                    if (!current.errors) {
                        current.errors = [];
                    }
                    result[key] = current;
                    if (res === null) {
                        return;
                    }
                    if (typeof res !== 'string') {
                        throw new Error('Not a valid error string!');
                    }
                    if (current.errors.indexOf(res) === -1) {
                        current.errors.push(res);
                    }
                }
                if (typeof res === 'string') {
                    innerAdd(key, res);
                    return;
                }
                if (isRecord(res)) {
                    var r = res;
                    for (var k in r) {
                        var isArray = Array.isArray(model[k]);
                        if (isArray) {
                            addToArray(k, r[k]);
                        }
                        else if (k === key) {
                            innerAdd(k, r[k]);
                            return;
                        }
                        else {
                            add(k, r[k]);
                        }
                    }
                    return;
                }
            }
            var result, target, validators, _a, _b, _i, key, propValue, propValidators, i, v, res, type, propKeys, _loop_2, this_1, i;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        result = {};
                        if (isPrimitive(model)) {
                            return [2 /*return*/, result];
                        }
                        target = model;
                        target = target.prototype === undefined ? target.constructor : target;
                        ;
                        ;
                        validators = this.getValidatorsFor(target);
                        _a = [];
                        for (_b in validators)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 7];
                        key = _a[_i];
                        if (!isInValidationPath(path + key, validationPath)) {
                            return [3 /*break*/, 6];
                        }
                        propValue = model[key];
                        propValidators = validators[key];
                        i = 0;
                        _c.label = 2;
                    case 2:
                        if (!(i < propValidators.length)) return [3 /*break*/, 6];
                        v = propValidators[i];
                        res = isFieldValidator(v) ? v.validate(propValue) : v(model, ctx, originalModel);
                        if (!(res instanceof Promise)) return [3 /*break*/, 4];
                        return [4 /*yield*/, res];
                    case 3:
                        res = _c.sent();
                        _c.label = 4;
                    case 4:
                        add(key, res);
                        _c.label = 5;
                    case 5:
                        i++;
                        return [3 /*break*/, 2];
                    case 6:
                        _i++;
                        return [3 /*break*/, 1];
                    case 7:
                        if (!model.getType) {
                            return [2 /*return*/, result];
                        }
                        type = model.getType();
                        propKeys = Object.keys(type.props);
                        _loop_2 = function () {
                            var key, prop, tag, tagContains, propValue, originalValue, current, innerResult, arrayRes, k, item, originalItem, innerResult, decodeResult;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        key = propKeys[i];
                                        if (!isInValidationPath(path + key, validationPath)) {
                                            return [2 /*return*/, "continue"];
                                        }
                                        prop = type.props[key];
                                        tag = prop['_tag'];
                                        tagContains = function (search) { return tag && tag.length > 0 ? tag.indexOf(search) != -1 : false; };
                                        propValue = model[key];
                                        originalValue = hasKey(originalModel, key) ? originalModel[key] : undefined;
                                        current = result[key];
                                        if (!(tag === "InterfaceType" || isTypedRecord(propValue))) return [3 /*break*/, 2];
                                        return [4 /*yield*/, this_1.validate(propValue, ctx, originalValue, validationPath, path + key + '.')];
                                    case 1:
                                        innerResult = _a.sent();
                                        if (current) {
                                            if (Object.keys(innerResult).length > 0) {
                                                result[key] = Object.assign(current, innerResult);
                                            }
                                        }
                                        else {
                                            result[key] = innerResult;
                                        }
                                        return [3 /*break*/, 8];
                                    case 2:
                                        if (!tagContains("ArrayType")) return [3 /*break*/, 7];
                                        arrayRes = result[key] || [];
                                        k = 0;
                                        _a.label = 3;
                                    case 3:
                                        if (!(k < propValue.length)) return [3 /*break*/, 6];
                                        item = propValue[k];
                                        originalItem = originalValue !== undefined && originalValue.length > k ? originalValue[k] : undefined;
                                        return [4 /*yield*/, this_1.validate(item, ctx, originalItem, validationPath, path + key + '[' + k + ']' + '.')];
                                    case 4:
                                        innerResult = _a.sent();
                                        arrayRes.push(innerResult);
                                        _a.label = 5;
                                    case 5:
                                        k++;
                                        return [3 /*break*/, 3];
                                    case 6:
                                        if (!arrayRes.errors) {
                                            arrayRes.errors = [];
                                        }
                                        ;
                                        result[key] = arrayRes;
                                        return [3 /*break*/, 8];
                                    case 7:
                                        if (!current) {
                                            result[key] = [];
                                        }
                                        decodeResult = prop.decode(propValue);
                                        if (decodeResult.isLeft()) {
                                            PathReporter_1.PathReporter.report(decodeResult).forEach(function (o) { return add(key, o); });
                                        }
                                        _a.label = 8;
                                    case 8: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        i = 0;
                        _c.label = 8;
                    case 8:
                        if (!(i < propKeys.length)) return [3 /*break*/, 11];
                        return [5 /*yield**/, _loop_2()];
                    case 9:
                        _c.sent();
                        _c.label = 10;
                    case 10:
                        i++;
                        return [3 /*break*/, 8];
                    case 11: return [2 /*return*/, result];
                }
            });
        });
    };
    ValidationRegistry.prototype.getRequiredFieldsFor = function (klass) {
        var classValidators = this.getValidatorsFor(klass);
        var res = {};
        for (var p in classValidators) {
            var required = false;
            var validators = classValidators[p];
            if (validators !== undefined) {
                validators.forEach(function (v) {
                    if (isRequiredFieldValidator(v)) {
                        required = true;
                    }
                });
            }
            res[p] = required;
        }
        return res;
    };
    return ValidationRegistry;
}());
exports.ValidationRegistry = ValidationRegistry;
function isValidationArray(input) {
    return Array.isArray(input) && Array.isArray(input.errors);
}
exports.isValidationArray = isValidationArray;
function isInValidationPath(currentPath, validationPath) {
    if (validationPath === null) {
        return true;
    }
    return validationPath.startsWith(currentPath);
}
function isValid(result) {
    var res = true;
    for (var p in result) {
        var prop = result[p];
        var isArray = Array.isArray(prop);
        var keys = isArray ? [] : Object.keys(prop);
        if (isArray) {
            if (isValidationArray(prop)) {
                if (prop.errors.length > 0) {
                    return false;
                }
                for (var i = 0; i < prop.length; i++) {
                    var entry = prop[i];
                    if (!isValid(entry)) {
                        return false;
                    }
                }
            }
            else if (prop.length > 0) {
                return false;
            }
        }
        else if (keys.length > 0) {
            if (!isValid(prop)) {
                return false;
            }
        }
    }
    return res;
}
exports.isValid = isValid;
function hasKey(input, key) {
    if (isPrimitive(input)) {
        return false;
    }
    return key in input;
}
function isTypedRecord(input) {
    if (isPrimitive(input)) {
        return false;
    }
    if (Array.isArray(input)) {
        return false;
    }
    if (input.getType) {
        return true;
    }
    return false;
}
function isRecord(input) {
    if (isPrimitive(input)) {
        return false;
    }
    if (Array.isArray(input)) {
        return false;
    }
    if (Object.keys(input).length > 0) {
        return true;
    }
    return false;
}
exports._privates = {
    isPrimitive: isPrimitive,
    isInValidationPath: isInValidationPath,
    hasKey: hasKey,
    isTypedRecord: isTypedRecord,
    isRecord: isRecord
};
//# sourceMappingURL=index.js.map