"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
require("mocha");
var m = require("io-ts-derive-class");
var t = require("io-ts");
var PathReporter_1 = require("io-ts/lib/PathReporter");
var index_1 = require("./index");
var registry = new index_1.ValidationRegistry();
function register(klass, map) {
    registry.register(klass, map);
}
var testCtx = { isTest: true };
function validate(model, originalModel, validationPath, path) {
    if (originalModel === void 0) { originalModel = undefined; }
    if (validationPath === void 0) { validationPath = null; }
    if (path === void 0) { path = '.'; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, registry.validate(model, testCtx, originalModel, validationPath, path)];
        });
    });
}
var PersonAddressType = t.type({
    StreetAddress1: t.string,
    StreetAddress2: t.string,
});
var PersonAddress = /** @class */ (function (_super) {
    __extends(PersonAddress, _super);
    function PersonAddress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return PersonAddress;
}(m.DeriveClass(PersonAddressType)));
var DateTimeOrNullType = t.union([m.DateTime, t.null]);
var PersonType = t.type({
    ID: t.number,
    FirstName: t.string,
    LastName: t.string,
    Address: m.ref(PersonAddress),
    Addresses: t.array(m.ref(PersonAddress)),
    SecondaryAddresses: t.array(m.ref(PersonAddress)),
    NullableAddress: t.union([m.ref(PersonAddress), t.null]),
    Birthdate: t.union([m.DateTime, t.null])
});
var Person = /** @class */ (function (_super) {
    __extends(Person, _super);
    function Person() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Person;
}(m.DeriveClass(PersonType)));
register(Person, {
    FirstName: [
        index_1.required('FirstName is required'),
        function (p, ctx, original) { return original !== undefined && original.FirstName === 'Test' && p.FirstName === 'new FirstName' ? 'original FirstName error' : null; },
        function (p) { return p.FirstName === "Separate field" ? { Birthdate: "Separate field error" } : null; }
    ],
    LastName: function (p) { return new Promise(function (resolve) {
        setTimeout(function () {
            resolve((p.LastName == null || p.LastName.length < 1 ? "LastName is required" : null));
        }, 1);
    }); },
    Addresses: function (p) { return p.Addresses == null || p.Addresses.length < 1 ? "Must have at least one address" : null; },
    SecondaryAddresses: [
        function (p) {
            if (!p.SecondaryAddresses || p.SecondaryAddresses.length < 1)
                return null;
            var first = p.SecondaryAddresses[0];
            if (first.StreetAddress1 !== "Test")
                return "First StreetAddress1 must equal Test";
            return null;
        },
        function (p) { return p.FirstName === 'Separate Array Field' ? { Addresses: 'Separate address array validated by first name' } : null; }
    ],
    NullableAddress: function (p) { return { FirstName: p.FirstName === 'Separate Nullable Field' ? 'Separate field against nullable address' : null }; }
});
register(PersonAddress, {
    StreetAddress1: index_1.required("StreetAddress1 is required"),
    StreetAddress2: index_1.required("StreetAddress2 is required"),
});
function getValidPerson() {
    return new Person({ FirstName: 'Test', LastName: 'TestLast',
        Address: new PersonAddress({ StreetAddress1: '123 Test St', StreetAddress2: 'Test' }),
        Addresses: [
            new PersonAddress({ StreetAddress1: 'Test', StreetAddress2: 'Test' })
        ]
    });
}
describe('Can validate Person', function () {
    it('FirstName is required', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("FirstName");
                    if (result.FirstName) {
                        chai_1.expect(result.FirstName).length(1);
                        chai_1.expect(result.FirstName[0]).eq("FirstName is required");
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it('LastName is required', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("LastName");
                    if (result.LastName) {
                        chai_1.expect(result.LastName).length(1);
                        chai_1.expect(result.LastName[0]).eq("LastName is required");
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it('Address StreetAddress1 is required', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("Address");
                    chai_1.expect(result.Address.StreetAddress1).length(1);
                    chai_1.expect(result.Address.StreetAddress1[0]).eq("StreetAddress1 is required");
                    return [2 /*return*/];
            }
        });
    }); });
    it('Must have at least one address', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("Addresses");
                    if (result.Addresses) {
                        chai_1.expect(result.Addresses).length(0);
                        chai_1.expect(result.Addresses.errors).length(1);
                        chai_1.expect(result.Addresses.errors[0]).eq("Must have at least one address");
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it('First address must have StreetAddress1', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, firstAddress;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    person.Addresses.push(new PersonAddress());
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("Addresses");
                    chai_1.expect(result.Addresses).length(1);
                    if (result.Addresses && result.Addresses.length > 0) {
                        chai_1.expect(result.Addresses).length(1);
                        chai_1.expect(result.Addresses.errors).length(0);
                        firstAddress = result.Addresses[0];
                        if (firstAddress && firstAddress.StreetAddress1) {
                            chai_1.expect(firstAddress.StreetAddress1).length(1);
                            chai_1.expect(firstAddress.StreetAddress1[0]).eq("StreetAddress1 is required");
                        }
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it('First SecondaryAddress must have StreetAddress1 equal to Test', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    person.SecondaryAddresses.push(new PersonAddress());
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("SecondaryAddresses");
                    chai_1.expect(result.SecondaryAddresses).length(1);
                    if (result.SecondaryAddresses) {
                        chai_1.expect(result.SecondaryAddresses.errors).length(1);
                        chai_1.expect(result.SecondaryAddresses.errors[0]).eq("First StreetAddress1 must equal Test");
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it('Valid path has empty errors array', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person({ FirstName: 'Test' });
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.FirstName.length).eq(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Use of validationPath only validates the given path', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    return [4 /*yield*/, validate(person, undefined, '.Address.StreetAddress2')];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("Address");
                    chai_1.expect(result.FirstName).eq(undefined);
                    chai_1.expect(result.Address.StreetAddress1).eq(undefined);
                    chai_1.expect(result.Address.StreetAddress2).length(1);
                    chai_1.expect(result.Address.StreetAddress2[0]).eq("StreetAddress2 is required");
                    return [2 /*return*/];
            }
        });
    }); });
    it('Use of validationPath against array only validates a single entry in the array', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person();
                    person.SecondaryAddresses.push(new PersonAddress());
                    person.SecondaryAddresses.push(new PersonAddress());
                    return [4 /*yield*/, validate(person, undefined, '.SecondaryAddresses[0].StreetAddress1')];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result).to.have.property("SecondaryAddresses");
                    chai_1.expect(result.SecondaryAddresses).length(person.SecondaryAddresses.length);
                    chai_1.expect(result.SecondaryAddresses.errors).length(1);
                    chai_1.expect(result.SecondaryAddresses.errors[0]).eq("First StreetAddress1 must equal Test");
                    return [2 /*return*/];
            }
        });
    }); });
    it('primitive fields are validated with io-ts', function () { return __awaiter(_this, void 0, void 0, function () {
        var id, person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    id = 'Not a real ID';
                    person = new Person();
                    person.ID = id;
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.ID.length).eq(1);
                    chai_1.expect(result.ID[0]).eq('Invalid value "Not a real ID" supplied to : number');
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can get required fields map for person', function () { return __awaiter(_this, void 0, void 0, function () {
        var fields;
        return __generator(this, function (_a) {
            fields = registry.getRequiredFieldsFor(Person);
            chai_1.expect(fields.FirstName).eq(true);
            chai_1.expect(fields.LastName).eq(false);
            return [2 /*return*/];
        });
    }); });
    it('Setting an invalid Birthdate results in a validation error', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, bd, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person({ FirstName: 'Test' });
                    bd = 'Invalid datetime';
                    person.Birthdate = bd;
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.Birthdate.length).eq(2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Setting an valid Birthdate results in no validation errors', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, bd, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = new Person({ FirstName: 'Test' });
                    bd = '0002-01-12T05:50:36.000Z';
                    person.Birthdate = bd;
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.Birthdate.length).eq(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can validate Date or null', function () { return __awaiter(_this, void 0, void 0, function () {
        var bd, decodeResult;
        return __generator(this, function (_a) {
            bd = '0002-01-12T05:50:36.000Z';
            decodeResult = DateTimeOrNullType.decode(bd);
            chai_1.expect(decodeResult.isLeft()).eq(false);
            if (decodeResult.isLeft()) {
                console.log(PathReporter_1.PathReporter.report(decodeResult));
            }
            return [2 /*return*/];
        });
    }); });
    it('Valid person results in valid validation result', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(true);
                    return [2 /*return*/];
            }
        });
    }); });
    it('isValidationArray correctly detects a ValidationArray<T>', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, x;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    x = index_1.isValidationArray(result.Addresses);
                    chai_1.expect(x).eq(true);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Invalid address results in invalid validation result', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.Address.StreetAddress1 = '';
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(false);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can validate nullable address', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.NullableAddress = new PersonAddress();
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.NullableAddress.StreetAddress1.length).eq(1);
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(false);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can validate against original model', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, originalPerson, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    originalPerson = new Person(JSON.parse(JSON.stringify(person)));
                    person.FirstName = "new FirstName";
                    return [4 /*yield*/, validate(person, originalPerson)];
                case 1:
                    result = _a.sent();
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(false);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Bad NullableAddress does not return array of strings', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.NullableAddress = new PersonAddress();
                    person.NullableAddress.StreetAddress1 = 'Test NullableAddress1';
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.NullableAddress).does.not.have.property('length');
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can register validator that displays error in separate field', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.FirstName = 'Separate field';
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(false);
                    chai_1.expect(result.Birthdate.length).eq(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Can register validator that displays error in separate field on array field', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result, valid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.FirstName = 'Separate Array Field';
                    return [4 /*yield*/, validate(person)];
                case 1:
                    result = _a.sent();
                    valid = index_1.isValid(result);
                    chai_1.expect(valid).eq(false);
                    chai_1.expect(result.Addresses.errors.length).eq(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Partial validation against separate field validator returns separate field', function () { return __awaiter(_this, void 0, void 0, function () {
        var person, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    person = getValidPerson();
                    person.FirstName = 'Separate Nullable Field';
                    return [4 /*yield*/, validate(person, undefined, '.NullableAddress.StreetAddress1')];
                case 1:
                    result = _a.sent();
                    chai_1.expect(result.FirstName.length).eq(1);
                    person.FirstName = 'Will not trigger Separate Nullable Field';
                    return [4 /*yield*/, validate(person, undefined, '.NullableAddress.StreetAddress1')];
                case 2:
                    result = _a.sent();
                    chai_1.expect(result).has.property('FirstName');
                    chai_1.expect(result.FirstName.length).eq(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('RequiredValidator validates correctly', function () { return __awaiter(_this, void 0, void 0, function () {
        var errorMessage;
        return __generator(this, function (_a) {
            errorMessage = 'is required!';
            chai_1.expect(index_1.required(errorMessage).validate(null)).eq(errorMessage);
            chai_1.expect(index_1.required(errorMessage).validate(undefined)).eq(errorMessage);
            chai_1.expect(index_1.required(errorMessage).validate('')).eq(errorMessage);
            chai_1.expect(index_1.required(errorMessage).validate([])).eq(errorMessage);
            chai_1.expect(index_1.required(errorMessage).validate('a')).is.null;
            chai_1.expect(index_1.required(errorMessage).validate('test')).is.null;
            chai_1.expect(index_1.required(errorMessage).validate(1)).is.null;
            chai_1.expect(index_1.required(errorMessage).validate(false)).is.null;
            chai_1.expect(index_1.required(errorMessage).validate(true)).is.null;
            chai_1.expect(index_1.required().validate(null)).eq('is required');
            return [2 /*return*/];
        });
    }); });
    it('MinValidator validates correctly', function () { return __awaiter(_this, void 0, void 0, function () {
        var errorMessage, validator;
        return __generator(this, function (_a) {
            errorMessage = 'must be at least 5';
            validator = index_1.min(5, errorMessage);
            chai_1.expect(validator.validate(null)).is.null;
            chai_1.expect(validator.validate(undefined)).is.null;
            chai_1.expect(validator.validate('')).eq(errorMessage);
            chai_1.expect(validator.validate('aaaa')).eq(errorMessage);
            chai_1.expect(validator.validate('aaaaa')).is.null;
            chai_1.expect(validator.validate(5)).is.null;
            chai_1.expect(validator.validate(4)).eq(errorMessage);
            chai_1.expect(validator.validate([])).eq(errorMessage);
            chai_1.expect(validator.validate([1, 2, 3, 4, 5])).is.null;
            chai_1.expect(index_1.min(5).validate('aaaa')).eq('must be at least 5 characters');
            chai_1.expect(index_1.min(5).validate([1, 2, 3, 4])).eq('must have at least 5 entries');
            chai_1.expect(index_1.min(5).validate({ length: 4 })).is.null;
            chai_1.expect(index_1.min(5).validate({ length: 6 })).is.null;
            chai_1.expect(index_1.min(5).validate(4)).eq('must be greater than 4');
            return [2 /*return*/];
        });
    }); });
    it('MaxValidator validates correctly', function () { return __awaiter(_this, void 0, void 0, function () {
        var errorMessage, validator;
        return __generator(this, function (_a) {
            errorMessage = 'may only be less than or equal to 5';
            validator = index_1.max(5, errorMessage);
            chai_1.expect(validator.validate(null)).is.null;
            chai_1.expect(validator.validate(undefined)).is.null;
            chai_1.expect(validator.validate('')).is.null;
            chai_1.expect(validator.validate('aaaa')).is.null;
            chai_1.expect(validator.validate('aaaaa')).is.null;
            chai_1.expect(validator.validate('aaaaaa')).eq(errorMessage);
            chai_1.expect(validator.validate(5)).is.null;
            chai_1.expect(validator.validate(4)).is.null;
            chai_1.expect(validator.validate(6)).eq(errorMessage);
            chai_1.expect(validator.validate([])).is.null;
            chai_1.expect(validator.validate([1, 2, 3, 4])).is.null;
            chai_1.expect(validator.validate([1, 2, 3, 4, 5])).is.null;
            chai_1.expect(validator.validate([1, 2, 3, 4, 5, 6])).eq(errorMessage);
            chai_1.expect(index_1.max(5).validate('aaaaaa')).eq('must be fewer than 6 characters');
            chai_1.expect(index_1.max(5).validate([1, 2, 3, 4, 5, 6])).eq('must be fewer than 6 entries');
            chai_1.expect(index_1.max(5).validate({ length: 6 })).is.null;
            chai_1.expect(index_1.max(5).validate({ length: 4 })).is.null;
            chai_1.expect(index_1.max(5).validate(6)).eq('must be less than 6');
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=index.spec.js.map